<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" @submit.native.prevent>
      <el-form-item label="账号状态" prop="state">
        <el-select v-model="queryParams.state" placeholder="账号状态" class="se" clearable>
          <el-option value="0" label="正常"></el-option>
          <el-option value="1" label="禁用"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-table :data="response.rows" border @selection-change="selects" height="calc(100vh - 230px)">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="微信openId" align="left" prop="openId" />
      <el-table-column label="绑定就诊人" align="center" width="160">
        <template slot-scope="scope">
          <el-tag type="success" v-if="scope.row.patientId">已绑定</el-tag>
          <el-tag type="danger" v-else>未绑定</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="当前绑定" prop="patientName" align="center" width="160" />
      <el-table-column label="账号状态" align="center" prop="state" width="110">
        <template slot-scope="scope">
          <div class="switch">
            <el-switch v-model="scope.row.state" :active-value="0" :width="50" :inactive-value="1" @change="op('change', scope.row)"></el-switch>
            <span class="zc" v-if="scope.row.state == 0" style="left: 22px">正常</span>
            <span class="ty" v-else style="left: 35px">禁用</span>
          </div>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" width="160" />
      <el-table-column label="操作" align="center" width="160">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-delete" @click="del(scope.row)" v-hasPermi="['work:user:remove']">删除</el-button>
        </template>
      </el-table-column>
      <template slot="empty">
        <el-empty></el-empty>
      </template>
    </el-table>
    <pagination v-if="response.total > 0" :total="response.total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />
  </div>
</template>

<script>
export default {
  name: 'User',
  data() {
    return {
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        openId: null,
        state: null,
        orderByColumn: 'id', //排序字段
        isAsc: 'desc' //排序方式
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    getList() {
      this.ajax({ url: '/work/user/list', data: this.queryParams }).then((response) => {
        this.response = response;
      });
    },
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    resetQuery() {
      this.resetForm('queryForm');
      this.handleQuery();
    },
    selects(rows) {
      this.ids = rows.map((item) => item.id);
    },
    op(tag, row) {
      //账号状态
      if (tag == 'change') {
        let text = row.state === 0 ? '启用' : '禁用';
        this.$confirm('确认要' + text + '该用户吗？', '警告', { type: 'warning' })
          .then(() => {
            this.post({ url: '/work/user/enable', data: { id: row.id, state: row.state } })
              .then((response) => {
                this.$modal.msgSuccess(text + '成功');
              })
              .catch(() => {
                row.state = row.state === 0 ? 1 : 0;
              });
          })
          .catch(() => {
            row.state = row.state === 0 ? 1 : 0;
          });
      }
    },
    del(row) {
      this.$confirm('是否确认删除选中数据?', '警告', { type: 'warning' }).then(() => {
        this.get({ url: '/work/user/remove/' + (row.id || this.ids) }).then((response) => {
          this.$modal.msgSuccess('删除成功');
          this.getList();
        });
      });
    }
  }
};
</script>
